/*************************************************************************************************
 * Writing test of Quick DataBase Manager in Java
 *************************************************************************************************/


import qdbm.*;


public class JavaTest {
  static final int LOOPNUM = 1000000;
  static final int BUCKETNUM = 2000000;
  static final String DBNAME = "casket.qdbm";
  public static void main(String[] args){
    Depot depot = null;
    try {
      depot = new Depot(DBNAME, Depot.OWRITER | Depot.OCREAT | Depot.OTRUNC, BUCKETNUM);
      for(int i = 1; i <= LOOPNUM; i++){
        byte[] buf = numstr(i, 8, '0').getBytes();
        depot.put(buf, buf);
        if(i % (LOOPNUM / 250) == 0){
          System.out.print('.');
          System.out.flush();
          if(i == LOOPNUM || i % (LOOPNUM / 10) == 0){
            System.out.println(" (" + new String(buf) + ")");
            System.out.flush();
          }
        }
      }
    } catch(DepotException e){
      e.printStackTrace();
    } finally {
      try {
        if(depot != null) depot.close();
      } catch(DepotException e){
        e.printStackTrace();
      }
    }
  }
  private static String numstr(int num, int cols, char padding){
    StringBuffer sb = new StringBuffer(cols);
    boolean minus = false;
    if(num < 0){
      num *= -1;
      cols--;
      minus = true;
    }
    int i = 0;
    while(num > 0){
      sb.insert(0, num % 10);
      num /= 10;
      i++;
    }
    while(i < cols){
      sb.insert(0, padding);
      i++;
    }
    if(minus) sb.insert(0, '-');
    return sb.toString();
  }
}



/* END OF FILE */
