#=================================================================================================
# Writing test of tied hash of Perl
#=================================================================================================


use strict;
use warnings;
use POSIX;
use SDBM_File;
use GDBM_File;
use DB_File;
use Depot;

use constant LOOPNUM => 1000000;
use constant BUCKETNUM => 2000000;
use constant DBNAME => "casket.perl";


# main routine
sub main {
    my(%hash, $default, $i, $len, $buf);
    $default = 0;
    if(scalar(@ARGV) > 0 && $ARGV[0] eq "-qdbm"){
        tie(%hash, "Depot", &DBNAME, Depot::OWRITER | Depot::OCREAT | Depot::OTRUNC, &BUCKETNUM);
    } elsif(scalar(@ARGV) > 0 && $ARGV[0] eq "-sdbm"){
        tie(%hash, "SDBM_File", &DBNAME, O_RDWR | O_CREAT | O_TRUNC, 00644);
    } elsif(scalar(@ARGV) > 0 && $ARGV[0] eq "-gdbm"){
        tie(%hash, "GDBM_File", &DBNAME, O_RDWR | O_CREAT | O_TRUNC, 00644);
    } elsif(scalar(@ARGV) > 0 && $ARGV[0] eq "-bdb"){
        tie(%hash, "DB_File", &DBNAME, O_RDWR | O_CREAT | O_TRUNC, 00644, $DB_HASH);
    } else {
        dbmopen(%hash, &DBNAME, 00644);
        $default = 1;
    }
    $| = 1;
    for($i = 1; $i <= &LOOPNUM; $i++){
        $buf = sprintf("%08d", $i);
        $hash{$buf} = $buf;
        if(&LOOPNUM > 250 && $i % (&LOOPNUM / 250) == 0){
            print('.');
            if($i == &LOOPNUM || $i % (&LOOPNUM / 10) == 0){
                printf(" (%08d)\n", $i);
            }
        }
    }
    if($default){
        dbmclose(%hash);
    } else {
        untie(%hash);
    }
    return 0;
}



exit(main());                            # execute main


# END OF FILE
