/*************************************************************************************************
 * Writing test of Quick DataBase Manager in C++
 *************************************************************************************************/


#include <xdepot.h>
#include <cstdlib>
#include <cstring>
#include <iostream>

using namespace std;
using namespace qdbm;

const int LOOPNUM = 1000000;
const int BUCKETNUM = 2000000;
const char* DBNAME = "casket.qdbm";


/* function prototypes */
int main(int argc, char **argv);


/* main routine */
int main(int argc, char **argv){
  int i, len;
  char buf[32];
  try {
    Depot depot(DBNAME, Depot::OWRITER | Depot::OCREAT | Depot::OTRUNC, BUCKETNUM);
    for(i = 1; i <= LOOPNUM; i++){
      len = sprintf(buf, "%08d", i);
      depot.put(buf, len, buf, len);
      if(LOOPNUM > 250 && i % (LOOPNUM / 250) == 0){
        putchar('.');
        fflush(stdout);
        if(i == LOOPNUM || i % (LOOPNUM / 10) == 0){
          printf(" (%08d)\n", i);
          fflush(stdout);
        }
      }
    }
    depot.close();
  } catch(Depot_error& e){
    cout << e.message() << endl;
  }
  return 0;
}



/* END OF FILE */
