#=================================================================================================
# Writing test of hash databases of Ruby
#=================================================================================================

require 'fcntl'
require 'dbm'
require 'sdbm'
require 'gdbm'
require 'depot'

LOOPNUM = 1000000
BUCKETNUM = 2000000
DBNAME = "casket.ruby"


# main routine
def main()
  hash = nil
  begin
    if(ARGV.length > 0 && ARGV[0] == "-qdbm")
      hash = Depot::new(DBNAME, Depot::OWRITER | Depot::OCREAT | Depot::OTRUNC, BUCKETNUM)
    elsif(ARGV.length > 0 && ARGV[0] == "-sdbm")
      hash = SDBM::new(DBNAME, 00644)
    elsif(ARGV.length > 0 && ARGV[0] == "-gdbm")
      hash = GDBM::open(DBNAME, 00644, Fcntl::O_RDWR | Fcntl::O_CREAT | Fcntl::O_TRUNC)
    else
      hash = DBM::open(DBNAME, 00644)
    end
    STDOUT.sync = true
    1.upto(LOOPNUM) do |i|
      buf = sprintf("%08d", i)
      hash[buf] = buf
      if(LOOPNUM > 250 && i % (LOOPNUM / 250) == 0)
        print(".")
        if(i == LOOPNUM || i % (LOOPNUM / 10) == 0)
          printf(" (%08d)\n", i)
        end
      end
    end
  ensure
    (!hash) || (hash.close())
  end
  return 0
end


exit(main());                            # execute main


# END OF FILE
